Index: cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas
===================================================================
--- cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas	(revision 1676)
+++ cprs/branches/HealthSevak-CPRS/CPRS-Lib/ORCtrls.pas	(revision 1693)
@@ -799,13 +807,13 @@
     FBlackColorMode: boolean;
     procedure SetFocusOnBox(value: boolean);
-    procedure CNMeasureItem    (var Message: TWMMeasureItem);   message CN_MEASUREITEM;
-    procedure CNDrawItem       (var Message: TWMDrawItem);      message CN_DRAWITEM;
-    procedure CMFontChanged    (var Message: TMessage);         message CM_FONTCHANGED;
-    procedure CMEnabledChanged (var Message: TMessage);         message CM_ENABLEDCHANGED;
-    procedure WMLButtonDblClk  (var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
-    procedure WMSize           (var Message: TWMSize);          message WM_SIZE;
-    procedure BMSetCheck       (var Message: TMessage);         message BM_SETCHECK;
-    procedure BMGetCheck       (var Message: TMessage);         message BM_GETCHECK;
-    procedure BMGetState       (var Message: TMessage);         message BM_GETSTATE;
+    procedure CNMeasureItem(var Message: TWMMeasureItem); message CN_MEASUREITEM;
+    procedure CNDrawItem(var Message: TWMDrawItem); message CN_DRAWITEM;
+    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
+    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
+    procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
+    procedure WMSize(var Message: TWMSize); message WM_SIZE;
+    procedure BMSetCheck(var Message: TMessage); message BM_SETCHECK;
+    procedure BMGetCheck(var Message: TMessage); message BM_GETCHECK;
+    procedure BMGetState(var Message: TMessage); message BM_GETSTATE;
     function GetImageList: TCustomImageList;
     function GetImageIndexes: string;
@@ -823,7 +831,7 @@
     procedure SetAutoSize(Value: boolean); override;
     procedure GetDrawData(CanvasHandle: HDC; var Bitmap: TBitmap;
-                                             var FocRect, Rect: TRect;
-                                             var DrawOptions: UINT;
-                                             var TempBitMap: boolean);
+      var FocRect, Rect: TRect;
+      var DrawOptions: UINT;
+      var TempBitMap: boolean);
     procedure DrawItem(const DrawItemStruct: TDrawItemStruct); dynamic;
     procedure Toggle; override;
@@ -908,5 +916,5 @@
   private
     FHoverItemPos: integer;
-    FRightClickSelect: boolean;                  // When true, a right click selects teh item
+    FRightClickSelect: boolean; // When true, a right click selects teh item
     FHintOnItem: boolean;
     procedure SetCaption(const Value: string);
@@ -941,4 +949,5 @@
   published
     property Caption: string read GetCaption write SetCaption;
+    Property CheckWidth: integer Read GetCheckWidth;
   end;
 
@@ -1010,6 +1019,6 @@
     procedure KeyUp(var Key: Word; Shift: TShiftState); override;
   public
-    procedure IndexToColRow( index: integer; var Col: integer; var Row: integer);
-    function ColRowToIndex( Col: integer; Row: Integer): integer;
+    procedure IndexToColRow(index: integer; var Col: integer; var Row: integer);
+    function ColRowToIndex(Col: integer; Row: Integer): integer;
     function SupportsDynamicProperty(PropertyID: integer): boolean;
     function GetDynamicProperty(PropertyID: integer): string;
@@ -1026,10 +1035,10 @@
 procedure GoodNotifyWinEvent(event: DWORD; hwnd: HWND; idObject, idChild: Longint); stdcall;
 
-function CalcShortName( LongName: string; PrevLongName: string): string;
+function CalcShortName(LongName: string; PrevLongName: string): string;
 
 {Returns True if any one of 3 mouse buttons are down left, right, or middle}
-function IsAMouseButtonDown : boolean;
-
-implementation  // ---------------------------------------------------------------------------
+function IsAMouseButtonDown: boolean;
+
+implementation // ---------------------------------------------------------------------------
 
 {$R ORCTRLS}
@@ -1037,32 +1046,32 @@
 uses
   VAUtils;
-  
+
 const
-  ALPHA_DISTRIBUTION: array[0..100] of string[3] = ('',' ','ACE','ADG','ALA','AMI','ANA','ANT',
-    'ARE','ASU','AZO','BCP','BIC','BOO','BST','CAF','CAR','CD6','CHE','CHO','CMC','CON','CPD',
-    'CVI','DAA','DEF','DEP','DIA','DIH','DIP','DP ','EAR','EM ','EPI','ETH','F2G','FIB','FML',
-    'FUM','GEL','GLU','GPQ','HAL','HEM','HIS','HUN','HYL','IDS','IND','INT','ISO','KEX','LAN',
-    'LEV','LOY','MAG','MAX','MER','MET','MIC','MON','MUD','NAI','NEU','NIT','NUC','OMP','OTH',
-    'P42','PAR','PEN','PHA','PHO','PLA','POL','PRA','PRO','PSE','PYR','RAN','REP','RIB','SAA',
-    'SCL','SFL','SMO','SPO','STR','SUL','TAG','TET','THI','TOL','TRI','TRY','UNC','VAR','VIT',
-    'WRO','ZYM',#127#127#127);
-
-  CBO_CYMARGIN =  8;           // vertical whitespace in the edit portion of combobox
-  CBO_CXBTN    = 13;           // width of drop down button in combobox
-  CBO_CXFRAME  =  5;           // offset to account for frame around the edit part of combobox
-
-  NOREDRAW = 0;                // suspend screen updates
-  DOREDRAW = 1;                // allow screen updates
-
-  KEY_TIMER_DELAY = 500;       // 500 ms delay after key up before OnKeyPause called
-  KEY_TIMER_ID = 5800;         // arbitrary, use high number in case TListBox uses timers
+  ALPHA_DISTRIBUTION: array[0..100] of string[3] = ('', ' ', 'ACE', 'ADG', 'ALA', 'AMI', 'ANA', 'ANT',
+    'ARE', 'ASU', 'AZO', 'BCP', 'BIC', 'BOO', 'BST', 'CAF', 'CAR', 'CD6', 'CHE', 'CHO', 'CMC', 'CON', 'CPD',
+    'CVI', 'DAA', 'DEF', 'DEP', 'DIA', 'DIH', 'DIP', 'DP ', 'EAR', 'EM ', 'EPI', 'ETH', 'F2G', 'FIB', 'FML',
+    'FUM', 'GEL', 'GLU', 'GPQ', 'HAL', 'HEM', 'HIS', 'HUN', 'HYL', 'IDS', 'IND', 'INT', 'ISO', 'KEX', 'LAN',
+    'LEV', 'LOY', 'MAG', 'MAX', 'MER', 'MET', 'MIC', 'MON', 'MUD', 'NAI', 'NEU', 'NIT', 'NUC', 'OMP', 'OTH',
+    'P42', 'PAR', 'PEN', 'PHA', 'PHO', 'PLA', 'POL', 'PRA', 'PRO', 'PSE', 'PYR', 'RAN', 'REP', 'RIB', 'SAA',
+    'SCL', 'SFL', 'SMO', 'SPO', 'STR', 'SUL', 'TAG', 'TET', 'THI', 'TOL', 'TRI', 'TRY', 'UNC', 'VAR', 'VIT',
+    'WRO', 'ZYM', #127#127#127);
+
+  CBO_CYMARGIN = 8; // vertical whitespace in the edit portion of combobox
+  CBO_CXBTN = 13; // width of drop down button in combobox
+  CBO_CXFRAME = 5; // offset to account for frame around the edit part of combobox
+
+  NOREDRAW = 0; // suspend screen updates
+  DOREDRAW = 1; // allow screen updates
+
+  KEY_TIMER_DELAY = 500; // 500 ms delay after key up before OnKeyPause called
+  KEY_TIMER_ID = 5800; // arbitrary, use high number in case TListBox uses timers
 
   { use high word to pass positioning flags since listbox is limited to 32767 items }
   //SFI_TOP = $80000000;         // top of listbox (decimal value: -2147483648)
   //SFI_END = $90000000;         // end of listbox (decimal value: -1879048192)
-  SFI_TOP = -2147483646;       // top of listbox (hex value: $80000001)
-  SFI_END = -1879048192;       // end of listbox (hex value: $90000000)
-
-  CheckWidth = 15;  // CheckBox Width space to reserve for TORListBox
+  SFI_TOP = -2147483646; // top of listbox (hex value: $80000001)
+  SFI_END = -1879048192; // end of listbox (hex value: $90000000)
+
+  CheckWidth = 15; // CheckBox Width space to reserve for TORListBox
   CheckComboBtnHeight = 21;
   MaxNeedDataLen = 64;
@@ -1071,10 +1080,10 @@
   TItemTip = class(TCustomControl)
   private
-    FShowing: Boolean;                           // true when itemtip is visible
-    FListBox: TORListBox;                        // current listbox displaying itemtips
+    FShowing: Boolean; // true when itemtip is visible
+    FListBox: TORListBox; // current listbox displaying itemtips
     FListItem: integer;
     FPoint: TPoint;
     FSelected: boolean;
-    FTabs: array[0..MAX_TABS] of Integer;         // Holds the pixel offsets for tabs
+    FTabs: array[0..MAX_TABS] of Integer; // Holds the pixel offsets for tabs
     procedure GetTabSettings;
   protected
@@ -1088,5 +1097,5 @@
   end;
 
-  TSizeRatio = class                             // relative sizes and positions for resizing
+  TSizeRatio = class // relative sizes and positions for resizing
     CLeft: Extended;
     CTop: Extended;
@@ -1097,9 +1106,9 @@
 
 var
-  uKeyHookHandle: HHOOK;       // handle to capture key events & hide ItemTip window
-  uItemTip: TItemTip;          // ItemTip window
-  uItemTipCount: Integer;      // number of ItemTip clients
-  uNewStyle: Boolean;          // True if using Windows 95 interface
-
+  uKeyHookHandle: HHOOK; // handle to capture key events & hide ItemTip window
+  uItemTip: TItemTip; // ItemTip window
+  uItemTipCount: Integer; // number of ItemTip clients
+  uNewStyle: Boolean; // True if using Windows 95 interface
+  HintArray: array of THintRecords;
 { General functions and procedures --------------------------------------------------------- }
 
@@ -1130,5 +1139,6 @@
     try
       GetTextExtentPoint32(DC, 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz', 52, Extent);
-      Result := Trunc((Extent.cx / 26 + 1) / 2);     // Round() doesn't line up with dialog units
+      //Find the average of the width then round up
+      Result := Trunc(Extent.cx / 52 ) + 1;
     finally
       SelectObject(DC, SaveFont);
@@ -1205,5 +1215,5 @@
   if i < PieceNum
     then x := x + StringOfChar(Delim, PieceNum - i) + NewPiece
-    else x := Copy(x, 1, Strt - PChar(x)) + NewPiece + StrPas(Next);
+  else x := Copy(x, 1, Strt - PChar(x)) + NewPiece + StrPas(Next);
 end;
 
@@ -1236,5 +1246,5 @@
     end;
     ANum := StrToIntDef(Trim(APiece), 0);
-    if(ANum > 0) or (AllowNeg and (ANum < 0)) then
+    if (ANum > 0) or (AllowNeg and (ANum < 0)) then
     begin
       Inc(IntArray[0]);
@@ -1262,11 +1272,11 @@
 { TItemTip --------------------------------------------------------------------------------- }
 
-procedure AddItemTipRef;     // kcm
-begin
-  if uItemTipCount = 0 then uItemTip := TItemTip.Create(Application);  // all listboxes share a single ItemTip window
+procedure AddItemTipRef; // kcm
+begin
+  if uItemTipCount = 0 then uItemTip := TItemTip.Create(Application); // all listboxes share a single ItemTip window
   Inc(uItemTipCount);
 end;
 
-procedure RemoveItemTipRef;  // kcm
+procedure RemoveItemTipRef; // kcm
 begin
   Dec(uItemTipCount);
@@ -1295,5 +1305,5 @@
   Params.Style := WS_POPUP or WS_DISABLED or WS_BORDER;
   if uNewStyle then Params.ExStyle := WS_EX_TOOLWINDOW;
-  Params.ExStyle := Params.ExStyle or WS_EX_TOPMOST;  // - test this!!
+  Params.ExStyle := Params.ExStyle or WS_EX_TOPMOST; // - test this!!
 end;
 
@@ -1314,5 +1324,5 @@
 // WARNING - Do NOT change the X pos or the tab starting pos - this will cause a missmatch
 // between the hint window and what the control displayes
-    TabbedTextOut(Handle, 0, y, PChar(AString), Length(AString), MAX_TABS+1, FTabs[0], 0);
+    TabbedTextOut(Handle, 0, y, PChar(AString), Length(AString), MAX_TABS + 1, FTabs[0], 0);
   end;
 end;
@@ -1335,9 +1345,9 @@
 var
   DX, X, i, count: integer;
-  
+
 begin
   Count := FListBox.FTabPix[0];
-  FTabs[0] := 1;     // Set first tab stop to location 1 for display purposes
-  if(Count = 1) then
+  FTabs[0] := 1; // Set first tab stop to location 1 for display purposes
+  if (Count = 1) then
   begin
     DX := FListBox.FTabPix[1];
@@ -1353,5 +1363,5 @@
   for i := 1 to MAX_TABS do
   begin
-    if(i <= Count) then
+    if (i <= Count) then
       FTabs[i] := FListBox.FTabPix[i] - 1
     else
@@ -1375,5 +1385,5 @@
     Canvas.Brush.Color := clHighlight;
     Canvas.Font.Color := clHighlightText;
-  end else                                            // the item is not selected
+  end else // the item is not selected
   begin
     Canvas.Brush.Color := FListBox.ItemTipColor;
@@ -1381,16 +1391,16 @@
   end;
   Caption := #9 + FListBox.DisplayText[FListItem];
-  if Copy(Caption, 1, 2) = '__' then Caption := ' ';  // so separators don't extend past window
+  if Copy(Caption, 1, 2) = '__' then Caption := ' '; // so separators don't extend past window
 
   GetTabSettings;
 
   AWidth := LOWORD(GetTabbedTextExtent(Canvas.Handle, PChar(Caption), Length(Caption),
-    MAX_TABS+1, FTabs[0]));
+    MAX_TABS + 1, FTabs[0]));
   // inherent scrollbar may not always be visible in a long list
   if FListBox.LongList
     then ListClientWidth := ClientWidthOfList(FListBox)
-    else ListClientWidth := FListBox.ClientWidth;
+  else ListClientWidth := FListBox.ClientWidth;
   X := FPoint.X;
-  if(FListBox.FCheckBoxes) then
+  if (FListBox.FCheckBoxes) then
   begin
     dec(ListClientWidth, CheckWidth);
@@ -1414,5 +1424,5 @@
   if (GetCaptureControl = nil) and CatchMouse then FListBox.MouseCapture := True;
   SetWindowPos(Handle, HWND_TOP, X, FPoint.Y, AWidth, FListBox.ItemHeight,
-               SWP_SHOWWINDOW or SWP_NOACTIVATE);
+    SWP_SHOWWINDOW or SWP_NOACTIVATE);
   Invalidate;
 end;
@@ -1422,5 +1432,5 @@
 { sets the canvas properties and window size and text depending on the item in the listbox }
 begin
-  if not AListBox.Visible then Exit;                  // added to support DropDown lists
+  if not AListBox.Visible then Exit; // added to support DropDown lists
   FListBox := AListBox;
   FListItem := AnItem;
@@ -1432,7 +1442,7 @@
 type
   TORCBImgIdx = (iiUnchecked, iiChecked, iiGrayed, iiQMark, iiBlueQMark,
-                 iiDisUnchecked, iiDisChecked, iiDisGrayed, iiDisQMark,
-                 iiFlatUnChecked, iiFlatChecked, iiFlatGrayed,
-                 iiRadioUnchecked, iiRadioChecked, iiRadioDisUnchecked, iiRadioDisChecked);
+    iiDisUnchecked, iiDisChecked, iiDisGrayed, iiDisQMark,
+    iiFlatUnChecked, iiFlatChecked, iiFlatGrayed,
+    iiRadioUnchecked, iiRadioChecked, iiRadioDisUnchecked, iiRadioDisChecked);
 
 const
@@ -1445,5 +1455,5 @@
     'ORCB_RADIO_DISABLED_UNCHECKED', 'ORCB_RADIO_DISABLED_CHECKED');
 
-   BlackCheckBoxImageResNames: array[TORCBImgIdx] of PChar = (
+  BlackCheckBoxImageResNames: array[TORCBImgIdx] of PChar = (
     'BLACK_ORLB_FLAT_UNCHECKED', 'BLACK_ORLB_FLAT_CHECKED', 'BLACK_ORLB_FLAT_GRAYED',
     'BLACK_ORCB_QUESTIONMARK', 'BLACK_ORCB_BLUEQUESTIONMARK',
@@ -1453,5 +1463,5 @@
     'BLACK_ORCB_RADIO_UNCHECKED', 'BLACK_ORCB_RADIO_CHECKED',
     'BLACK_ORCB_RADIO_DISABLED_UNCHECKED', 'BLACK_ORCB_RADIO_DISABLED_CHECKED');
-  
+
 var
   ORCBImages: array[TORCBImgIdx, Boolean] of TBitMap;
@@ -1461,5 +1471,5 @@
   ResName: string;
 begin
-  if(not assigned(ORCBImages[Idx, BlackMode])) then
+  if (not assigned(ORCBImages[Idx, BlackMode])) then
   begin
     ORCBImages[Idx, BlackMode] := TBitMap.Create;
@@ -1483,5 +1493,5 @@
     for Mode := false to true do
     begin
-      if(assigned(ORCBImages[i, Mode])) then
+      if (assigned(ORCBImages[i, Mode])) then
         ORCBImages[i, Mode].Free;
     end;
@@ -1491,5 +1501,5 @@
 { TORStrings }
 
-function TORStrings.Add(const S: string): integer; 
+function TORStrings.Add(const S: string): integer;
 var
   RealVerification: Boolean;
@@ -1580,5 +1590,5 @@
 var
   RealVerification: Boolean;
-begin  //If this method weren't overridden, the listbox would forget which item was selected.
+begin //If this method weren't overridden, the listbox would forget which item was selected.
   MList[Index] := S;
   RealVerification := Verification;
@@ -1611,13 +1621,13 @@
   if Verification then begin
     if not Assigned(FPlainText) then
-      raise Exception.Create( 'ORStrings is missing PlainText property.');
+      raise Exception.Create('ORStrings is missing PlainText property.');
     if not Assigned(FTranslator) then
-      raise Exception.Create( 'ORStrings is missing Translator property.');
+      raise Exception.Create('ORStrings is missing Translator property.');
     Errors := TStringList.Create;
     try
       TotalCount := MList.Count;
       if MList.Count <> PlainText.Count then begin
-        Errors.Add('M string count:'+IntToStr(MList.Count));
-        Errors.Add('Plain string count:'+IntToStr(PlainText.Count));
+        Errors.Add('M string count:' + IntToStr(MList.Count));
+        Errors.Add('Plain string count:' + IntToStr(PlainText.Count));
         if PlainText.Count > TotalCount then
           TotalCount := PlainText.Count;
@@ -1625,12 +1635,12 @@
       for i := 0 to TotalCount - 1 do begin
         if i >= MList.Count then
-          Errors.Add('PlainText['+IntToStr(i)+']: '+PlainText[i])
+          Errors.Add('PlainText[' + IntToStr(i) + ']: ' + PlainText[i])
         else if i >= PlainText.Count then
-          Errors.Add('ORStrings['+IntToStr(i)+']: '+Translator(MList[i]))
+          Errors.Add('ORStrings[' + IntToStr(i) + ']: ' + Translator(MList[i]))
         else begin
           M := Translator(MList[i]);
           Plain := PlainText[i];
           if M <> Plain then begin
-            if UpperCase(M) = UpperCase(Plain) then  //Listboxes don't always sort cases right, so we give them a little help here.
+            if UpperCase(M) = UpperCase(Plain) then //Listboxes don't always sort cases right, so we give them a little help here.
             begin
               PlainText[i] := M;
@@ -1638,6 +1648,6 @@
             else
             begin
-              Errors.Add('PlainText['+IntToStr(i)+']: '+Plain);
-              Errors.Add('ORStrings['+IntToStr(i)+']: '+M);
+              Errors.Add('PlainText[' + IntToStr(i) + ']: ' + Plain);
+              Errors.Add('ORStrings[' + IntToStr(i) + ']: ' + M);
             end;
           end;
@@ -1645,6 +1655,6 @@
       end;
       if Errors.Count > 0 then begin
-        Errors.Insert( 0, 'OR strings are out of sync with plain text strings :');
-        raise Exception.Create( Errors.Text);
+        Errors.Insert(0, 'OR strings are out of sync with plain text strings :');
+        raise Exception.Create(Errors.Text);
       end;
     finally
@@ -1691,5 +1701,5 @@
   if uItemTip <> nil then uItemTip.Hide;
   DestroyItems;
-  RemoveItemTipRef;  //kcm
+  RemoveItemTipRef; //kcm
   inherited Destroy;
 end;
@@ -1711,5 +1721,5 @@
   FFromSelf := True;
   RealVerification := True;
-  if Assigned( FMItems ) then
+  if Assigned(FMItems) then
   begin
     RealVerification := FMItems.Verification;
@@ -1717,5 +1727,5 @@
   end;
   inherited CreateWnd;
-  if Assigned( FMItems ) then
+  if Assigned(FMItems) then
   begin
     FMItems.Verification := RealVerification;
@@ -1763,15 +1773,15 @@
 function TORListBox.IsSynonym(const TestStr: string): boolean;
 var
-  i,cnt,len :integer;
+  i, cnt, len: integer;
 
 begin
   Result := FALSE;
-  if((FHideSynonyms) and (FSynonymChars <> '')) then
+  if ((FHideSynonyms) and (FSynonymChars <> '')) then
   begin
     len := length(FSynonymChars);
     cnt := 0;
     for i := 1 to len do
-      if(pos(FSynonymChars[i], TestStr)>0) then inc(cnt);
-    if(cnt = len) then Result := TRUE;
+      if (pos(FSynonymChars[i], TestStr) > 0) then inc(cnt);
+    if (cnt = len) then Result := TRUE;
     if assigned(FOnSynonymCheck) then
       FOnSynonymCheck(Self, TestStr, Result);
@@ -1787,5 +1797,5 @@
   Result := '';
   FFromSelf := True;
-  Len := SendMessage(Handle,LB_GETTEXT, Index, Integer(@Buf));
+  Len := SendMessage(Handle, LB_GETTEXT, Index, Integer(@Buf));
   FFromSelf := False;
   if Len > 0 then
@@ -1818,11 +1828,11 @@
   inherited;
   if not FFromSelf then with Message do
-  begin
-    ItemRec := PItemRec(Result);
-    if(assigned(ItemRec)) then
-      Result := Integer(ItemRec^.UserObject)
-    else
-      Result := 0;
-  end;
+    begin
+      ItemRec := PItemRec(Result);
+      if (assigned(ItemRec)) then
+        Result := Integer(ItemRec^.UserObject)
+      else
+        Result := 0;
+    end;
 end;
 
@@ -1833,14 +1843,14 @@
 begin
   if not FFromSelf then with Message do
-  begin
-    FFromSelf := True;
-    ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, WParam, 0));  // WParam: list index
-    FFromSelf := False;
-    if(assigned(ItemRec)) then
-      ItemRec^.UserObject := TObject(LParam);
-    LParam := Integer(ItemRec);
-    if uItemTip.FShowing and (uItemTip.FListBox = Self) and (uItemTip.FListItem = WParam) then
-      uItemTip.UpdateText(FALSE);
-  end;
+    begin
+      FFromSelf := True;
+      ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, WParam, 0)); // WParam: list index
+      FFromSelf := False;
+      if (assigned(ItemRec)) then
+        ItemRec^.UserObject := TObject(LParam);
+      LParam := Integer(ItemRec);
+      if uItemTip.FShowing and (uItemTip.FListBox = Self) and (uItemTip.FListItem = WParam) then
+        uItemTip.UpdateText(FALSE);
+    end;
   inherited;
 end;
@@ -1854,23 +1864,24 @@
   inherited;
   if (not FFromSelf) and (Message.Result <> LB_ERR) then with Message do
-  begin
-    FFromSelf := True;
-    ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, WParam, 0));  // WParam: list index
-    FFromSelf := False;
-    if(assigned(ItemRec)) then
     begin
       FFromSelf := True;
-      Text := TListBox(self).Items[WParam];
-      StrCopy(PChar(LParam), PChar(Text));          // LParam: points string buffer
-      Result := Length(Text);                       // Result: length of string
+      ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, WParam, 0)); // WParam: list index
       FFromSelf := False;
-    end
-    else
-    begin
-      StrPCopy(PChar(LParam),'');
-      Result := 0;
-    end;
-  end;
-end;
+      if (assigned(ItemRec)) then
+      begin
+        FFromSelf := True;
+        Text := TListBox(self).Items[WParam];
+        StrCopy(PChar(LParam), PChar(Text)); // LParam: points string buffer
+        Result := Length(Text); // Result: length of string
+        FFromSelf := False;
+      end
+      else
+      begin
+        StrPCopy(PChar(LParam), '');
+        Result := 0;
+      end;
+    end;
+end;
+
 procedure TORListBox.LBGetTextLen(var Message: TMessage);
 { intercept LB_GETTEXTLEN and return true length of ItemRec^.FullText }
@@ -1881,13 +1892,13 @@
   inherited;
   if (not FFromSelf) and (Message.Result <> LB_ERR) then with Message do
-  begin
-    FFromSelf := True;
-    ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, WParam, 0));
-    if(assigned(ItemRec)) then
-      Result := Length(TListBox(self).Items[WParam])    // Result:length of string
-    else
-      Result := 0;
-    FFromSelf := False;
-  end;
+    begin
+      FFromSelf := True;
+      ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, WParam, 0));
+      if (assigned(ItemRec)) then
+        Result := Length(TListBox(self).Items[WParam]) // Result:length of string
+      else
+        Result := 0;
+      FFromSelf := False;
+    end;
 end;
 
@@ -1900,13 +1911,13 @@
   if not FFromSelf then
   begin
-    if FLongList then                               // -- special long list processing - begin
+    if FLongList then // -- special long list processing - begin
     begin
       if FFromNeedData then FDataAdded := True else with Message do
-      begin
-        WParam := FWaterMark;
-        Result := Perform(LB_INSERTSTRING, WParam, LParam);   // always insert into short list
-        Exit;
-      end;
-    end;                                            // -- special long list processing - end
+        begin
+          WParam := FWaterMark;
+          Result := Perform(LB_INSERTSTRING, WParam, LParam); // always insert into short list
+          Exit;
+        end;
+    end; // -- special long list processing - end
     New(ItemRec);
     with ItemRec^, Message do
@@ -1922,10 +1933,10 @@
     DoChange;
     with Message do if Result <> LB_ERR then
-    begin
-      FFromSelf := True;
-      SendMessage(Handle,LB_SETITEMDATA, Result, Integer(ItemRec));  // Result: new item index
-      FFromSelf := False;
-    end
-    else Dispose(ItemRec);
+      begin
+        FFromSelf := True;
+        SendMessage(Handle, LB_SETITEMDATA, Result, Integer(ItemRec)); // Result: new item index
+        FFromSelf := False;
+      end
+      else Dispose(ItemRec);
   end
   else inherited;
@@ -1939,5 +1950,5 @@
   if not FFromSelf then
   begin
-    if FLongList then                               // -- special long list processing - begin
+    if FLongList then // -- special long list processing - begin
     begin
       if FFromNeedData then
@@ -1947,13 +1958,13 @@
       end
       else with Message do
-      begin
-        if WParam > FWaterMark then
-        begin                                       // make sure insert above watermark
-          FMItems.MList.Move(WParam,FWaterMark);
-          WParam := FWaterMark;
+        begin
+          if WParam > FWaterMark then
+          begin // make sure insert above watermark
+            FMItems.MList.Move(WParam, FWaterMark);
+            WParam := FWaterMark;
+          end;
+          Inc(FWaterMark);
         end;
-        Inc(FWaterMark);
-      end;
-    end;                                            // -- special long list processing - end
+    end; // -- special long list processing - end
     New(ItemRec);
     with ItemRec^, Message do
@@ -1968,10 +1979,10 @@
     DoChange;
     with Message do if Result <> LB_ERR then
-    begin
-      FFromSelf := True;
-      SendMessage(Handle,LB_SETITEMDATA, Result, Integer(ItemRec)); // Result: new item index
-      FFromSelf := False;
-    end
-    else Dispose(ItemRec);
+      begin
+        FFromSelf := True;
+        SendMessage(Handle, LB_SETITEMDATA, Result, Integer(ItemRec)); // Result: new item index
+        FFromSelf := False;
+      end
+      else Dispose(ItemRec);
   end
   else inherited;
@@ -1986,7 +1997,7 @@
   begin
     FFromSelf := True;
-    ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, WParam, 0));  // WParam: list index
+    ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, WParam, 0)); // WParam: list index
     FFromSelf := False;
-    if(assigned(ItemRec)) then
+    if (assigned(ItemRec)) then
     begin
       if FLongList and not FFromNeedData then
@@ -1995,7 +2006,7 @@
     end;
   end;
-  FFromSelf := True;   // FFromSelf is set here because, under NT, LBResetContent is called
-  inherited;           // when deleting the last string from the listbox.  Since ItemRec is
-  FFromSelf := False;  // already disposed, it shouldn't be disposed again.
+  FFromSelf := True; // FFromSelf is set here because, under NT, LBResetContent is called
+  inherited; // when deleting the last string from the listbox.  Since ItemRec is
+  FFromSelf := False; // already disposed, it shouldn't be disposed again.
   DoChange;
 end;
@@ -2013,5 +2024,5 @@
     begin
       FFromSelf := True;
-      ItemRec := PItemRec(SendMessage(Handle,LB_GETITEMDATA, i, 0));
+      ItemRec := PItemRec(SendMessage(Handle, LB_GETITEMDATA, i, 0));
       FFromSelf := False;
       Dispose(ItemRec);
@@ -2049,15 +2060,15 @@
   case Message.CharCode of
     VK_LBUTTON, VK_RETURN, VK_SPACE:
-    begin
-      if (FocusIndex < 0) and (CheckBoxes or MultiSelect) and (Count > 0) then // JNM - 508 compliance
-        SetFocusIndex(0);
-      if FocusIndex > -1 then
       begin
-        if MultiSelect then
+        if (FocusIndex < 0) and (CheckBoxes or MultiSelect) and (Count > 0) then // JNM - 508 compliance
+          SetFocusIndex(0);
+        if FocusIndex > -1 then
         begin
-          IsSelected := LongBool(Perform(LB_GETSEL, FocusIndex, 0));
-          Perform(LB_SETSEL, Longint(not IsSelected), FocusIndex);
-        end
-        else Perform(LB_SETCURSEL, FocusIndex, 0);
+          if MultiSelect then
+          begin
+            IsSelected := LongBool(Perform(LB_GETSEL, FocusIndex, 0));
+            Perform(LB_SETSEL, Longint(not IsSelected), FocusIndex);
+          end
+          else Perform(LB_SETCURSEL, FocusIndex, 0);
         // Send WM_COMMAND here because LBN_SELCHANGE not triggered by LB_SETSEL
         // and LBN_SELCHANGE is what eventually triggers the Click event.
@@ -2067,17 +2078,17 @@
         //PostMessage() not SendMessage() is Required here for checkboxes, SendMessage() doesn't
         //Allow the Checkbox state on the control to be updated
-        if CheckBoxes then
-          PostMessage(Parent.Handle, WM_COMMAND, MAKELONG(FocusIndex, LBN_SELCHANGE), LPARAM(Handle))
-        else
-          SendMessage(Parent.Handle, WM_COMMAND, MAKELONG(FocusIndex, LBN_SELCHANGE), LPARAM(Handle));
+          if CheckBoxes then
+            PostMessage(Parent.Handle, WM_COMMAND, MAKELONG(FocusIndex, LBN_SELCHANGE), LPARAM(Handle))
+          else
+            SendMessage(Parent.Handle, WM_COMMAND, MAKELONG(FocusIndex, LBN_SELCHANGE), LPARAM(Handle));
+        end;
       end;
-    end;
-    VK_PRIOR:          SetFocusIndex(FocusIndex - FLargeChange);
-    VK_NEXT:           SetFocusIndex(FocusIndex + FLargeChange);
-    VK_END:            SetFocusIndex(SFI_END);
-    VK_HOME:           SetFocusIndex(SFI_TOP);
-    VK_LEFT, VK_UP:    SetFocusIndex(FocusIndex - 1);
+    VK_PRIOR: SetFocusIndex(FocusIndex - FLargeChange);
+    VK_NEXT: SetFocusIndex(FocusIndex + FLargeChange);
+    VK_END: SetFocusIndex(SFI_END);
+    VK_HOME: SetFocusIndex(SFI_TOP);
+    VK_LEFT, VK_UP: SetFocusIndex(FocusIndex - 1);
     VK_RIGHT, VK_DOWN: SetFocusIndex(FocusIndex + 1);
-    else inherited;
+  else inherited;
   end;
   Message.Result := 0;
